<?php

abstract class Upload
{
    const PATH_ROOT = '/var/www/10ballov/face/htdocs';
    public static function getGreagwarImage($file_path)
    {
        require_once PATH . '/lib/GreagwarImage/GreagwarImage.php';
        $greagwar_image = new GreagwarImage($file_path);
        $greagwar_image->setCacheDir(self::PATH_ROOT . '/media/cache/images');
        return $greagwar_image;
    }
    /**
     * @param $file array (ex. ['tmp_name' => '...', 'name' => '...', 'type' => '...'])
     * @param $force_create_variants bool
     * @return Image
     */
    public static function image($file, $force_create_variants = true)
    {
        $image = new Image;
        $image->original_filename = $file['name'];
        $greagwar_image = self::getGreagwarImage($file['tmp_name']);
        self::saveImage($image, $greagwar_image);
        if ($force_create_variants) {
            foreach (Image::$sizes as $size) {
                $size_parts = explode('x', $size);
                self::saveImage($image->getVariant($size), $greagwar_image, $size_parts[0] ? : null, $size_parts[1] ? : null);
            }
        }
        return $image;
    }

    /**
     * @param $image Image
     * @param $greagwar_image GreagwarImage
     * @param null $width
     * @param null $height
     * @param bool $crop
     */
    public static function saveImage($image, $greagwar_image, $width = null, $height = null, $crop = true)
    {
        $greagwar_image = clone($greagwar_image);
        if ($width || $height) {
            $greagwar_image->resize($width, $height, 0xffffff, false, false, $crop);
        }
        $image->type = $greagwar_image->guessType();
        $file_path = $greagwar_image->cacheFile($image->type, 87, true);
        $image->size = filesize($file_path);
        $path_parts = pathinfo($file_path);
        $image->path = preg_replace('#^' . self::PATH_ROOT . '/#', '', $path_parts['dirname']);
        $image->filename = $path_parts['basename'];
        $image->width = $greagwar_image->width();
        $image->height = $greagwar_image->height();
    }
}